// TabPageTwo.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "Eapi.h"
#include "Eapi_Seco.h"
#include "TabPage4.h"


// CTabPageFour dialog

IMPLEMENT_DYNAMIC(CTabPageFour, CDialog)
CTabPageFour::CTabPageFour(CWnd* pParent /*=NULL*/)
	: CDialog(CTabPageFour::IDD, pParent)
	, m_Fan_Cycle(0)
	, m_Fan_Duty(0)
{
}

CTabPageFour::~CTabPageFour()
{
}

void CTabPageFour::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_SET_FAN_CYCLE, m_Fan_Cycle);
	DDX_Text(pDX, IDC_SET_FAN_DUTY, m_Fan_Duty);
	DDX_Control(pDX, IDC_FAN_RPS, m_Fan_RPM);
	DDX_Control(pDX, IDC_FAN_RPS2, m_Fan_RPM2);
}


BEGIN_MESSAGE_MAP(CTabPageFour, CDialog)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(IDC_ENABLE_FAN, OnBnClickedEnableFAN)
	ON_BN_CLICKED(IDC_DISABLE_FAN, OnBnClickedDisableFAN)
	ON_BN_CLICKED(IDC_SET_CYCLE, OnBnClickedSetCycle)
	ON_BN_CLICKED(IDC_GET_CYCLE, OnBnClickedGetCycle)
	ON_BN_CLICKED(IDC_GET_DUTYCYCLE, OnBnClickedGetDutyCycle)
	ON_BN_CLICKED(IDC_SET_DUTYCYCLE, &CTabPageFour::OnBnClickedSetDutyCycle)
END_MESSAGE_MAP()


// CTabPageFour message handlers

void CTabPageFour::OnBnClickedOk()
{
	// TODO: Add your control notification handler code here

}
void CTabPageFour::OnBnClickedEnableFAN()
{
	unsigned long dwRet = 0;

	UpdateData(true);

	switch(EApiFanEnable(m_Fan_Cycle, m_Fan_Duty))
	{
		case EAPI_STATUS_SUCCESS:
			GetDlgItem(IDC_ENABLE_FAN)->EnableWindow(FALSE);
			GetDlgItem(IDC_DISABLE_FAN)->EnableWindow(TRUE);
			GetDlgItem(IDC_SET_CYCLE)->EnableWindow(TRUE);
			GetDlgItem(IDC_SET_DUTYCYCLE)->EnableWindow(TRUE);
			GetDlgItem(IDC_GET_CYCLE)->EnableWindow(TRUE);
			GetDlgItem(IDC_GET_DUTYCYCLE)->EnableWindow(TRUE);
			break;
		case EAPI_STATUS_NOT_INITIALIZED:
			MessageBox(TEXT("EAPI_STATUS_NOT_INITIALIZED"), 0, 0);
			break;
		case EAPI_STATUS_UNSUPPORTED:
			MessageBox(TEXT("EAPI_STATUS_UNSUPPORTED"), 0, 0);
			break;
		case EAPI_STATUS_ERROR:
		default:
			MessageBox(TEXT("EAPI_STATUS_ERROR"), 0, 0);
			break;
	}

	return;
}

void CTabPageFour::OnBnClickedDisableFAN()
{
	unsigned long dwRet = 0;

	switch(EApiFanDisable())
	{
		case EAPI_STATUS_SUCCESS:
			GetDlgItem(IDC_ENABLE_FAN)->EnableWindow(TRUE);
			GetDlgItem(IDC_DISABLE_FAN)->EnableWindow(FALSE);
			GetDlgItem(IDC_SET_CYCLE)->EnableWindow(FALSE);
			GetDlgItem(IDC_SET_DUTYCYCLE)->EnableWindow(FALSE);
			GetDlgItem(IDC_GET_CYCLE)->EnableWindow(FALSE);
			GetDlgItem(IDC_GET_DUTYCYCLE)->EnableWindow(FALSE);
			break;
		case EAPI_STATUS_NOT_INITIALIZED:
			MessageBox(TEXT("EAPI_STATUS_NOT_INITIALIZED"), 0, 0);
			break;
		case EAPI_STATUS_UNSUPPORTED:
			MessageBox(TEXT("EAPI_STATUS_UNSUPPORTED"), 0, 0);
			break;
		case EAPI_STATUS_ERROR:
		default:
			MessageBox(TEXT("EAPI_STATUS_ERROR"), 0, 0);
			break;
	}

	return;
}

void CTabPageFour::OnBnClickedGetCycle()
{
	unsigned long dwRet = 0;

	switch(EApiFanPWMGetCycle(&m_Fan_Cycle))
	{
		case EAPI_STATUS_SUCCESS:
			break;
		case EAPI_STATUS_NOT_INITIALIZED:
			MessageBox(TEXT("EAPI_STATUS_NOT_INITIALIZED"), 0, 0);
			break;
		case EAPI_STATUS_UNSUPPORTED:
			MessageBox(TEXT("EAPI_STATUS_UNSUPPORTED"), 0, 0);
			break;
		case EAPI_STATUS_ERROR:
		default:
			MessageBox(TEXT("EAPI_STATUS_ERROR"), 0, 0);
			break;
	}

	UpdateData(false);

	return;
}

void CTabPageFour::OnBnClickedSetCycle()
{

	UpdateData(true);

	switch(EApiFanPWMSetCycle(m_Fan_Cycle))
	{
		case EAPI_STATUS_SUCCESS:
			break;
		case EAPI_STATUS_NOT_INITIALIZED:
			MessageBox(TEXT("EAPI_STATUS_NOT_INITIALIZED"), 0, 0);
			break;
		case EAPI_STATUS_UNSUPPORTED:
			MessageBox(TEXT("EAPI_STATUS_UNSUPPORTED"), 0, 0);
			break;
		case EAPI_STATUS_ERROR:
		default:
			MessageBox(TEXT("EAPI_STATUS_ERROR"), 0, 0);
			break;
	}

	return;
}

void CTabPageFour::OnBnClickedGetDutyCycle()
{
	switch(EApiFanPWMGetDutyCycle(&m_Fan_Duty))
	{
		case EAPI_STATUS_SUCCESS:
			break;
		case EAPI_STATUS_NOT_INITIALIZED:
			MessageBox(TEXT("EAPI_STATUS_NOT_INITIALIZED"), 0, 0);
			break;
		case EAPI_STATUS_UNSUPPORTED:
			MessageBox(TEXT("EAPI_STATUS_UNSUPPORTED"), 0, 0);
			break;
		case EAPI_STATUS_ERROR:
		default:
			MessageBox(TEXT("EAPI_STATUS_ERROR"), 0, 0);
			break;
	}

	UpdateData(false);

	return;
}

void CTabPageFour::OnBnClickedSetDutyCycle()
{
	UpdateData(true);
	
	switch(EApiFanPWMSetDutyCycle(m_Fan_Cycle, m_Fan_Duty))
	{
		case EAPI_STATUS_SUCCESS:
			break;
		case EAPI_STATUS_NOT_INITIALIZED:
			MessageBox(TEXT("EAPI_STATUS_NOT_INITIALIZED"), 0, 0);
			break;
		case EAPI_STATUS_UNSUPPORTED:
			MessageBox(TEXT("EAPI_STATUS_UNSUPPORTED"), 0, 0);
			break;
		case EAPI_STATUS_ERROR:
		default:
			MessageBox(TEXT("EAPI_STATUS_ERROR"), 0, 0);
			break;
	}

	return;
}
